package lab.game;

import java.io.Serial;
import java.io.Serializable;

import javafx.scene.canvas.GraphicsContext;

public abstract class WorldEntity implements DrawableSimulable, Serializable {

	@Serial
	private static final long serialVersionUID = 8500258821894708841L;
	
	protected transient Scene scene;
	protected MyPoint position;
	private int zIndex;

	public WorldEntity(Scene scene, MyPoint position, int zIndex) {
		this.scene = scene;
		this.position = position;
		this.zIndex = zIndex;
	}

	public MyPoint getPosition() {
		return position;
	}

	public Scene getScene() {
		return scene;
	}

	@Override
	public final void draw(GraphicsContext gc) {
		gc.save();
		drawInternal(gc);
		gc.restore();
	}

	
	public int getZIndex() {
		return zIndex;
	}

	public abstract void drawInternal(GraphicsContext gc);
}
