package lab.gui;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javafx.collections.ListChangeListener;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.geometry.HPos;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.SelectionMode;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableRow;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleButton;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Text;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import lab.Setup;
import lab.data.Score;
import lab.game.Difficult;
import lombok.Setter;

/**
 * 
 */
public class EditController {

	private static Logger log = LogManager.getLogger(EditController.class);

	@FXML
	private Button btnOk;

	@FXML
	private Button btnCancel;

	@FXML
	private Label txtTitle;

	@FXML
	private GridPane content;

	private Object data;

	private App app;

	private Map<String, TextField> nameToTextField = new HashMap<>();

	@Setter
	private Stage stage;

	@Setter
	private MainScreenController mainScreenController;

	@FXML
	void btnOkAction(ActionEvent event) {
		//TODO: add code to read values from text fields
		
		mainScreenController.updateData((Score)data);
		stage.hide();
	}

	@FXML
	void btnCancelAction(ActionEvent event) {
		stage.hide();
	}

	@FXML
	void initialize() {
		log.info("Screen initialized.");
	}

	public void setObjectToEdit(Object data) {
		this.data = data;
		log.info("data set {}", data);
		content.getChildren().clear();
		
		//TODO: code to detect properties and add rows to dialog  
	}

	private void addDialogRow(int rowNumber, String name, String descriptionName, String stringValue,
			boolean editable) {
		Label label = new Label(descriptionName);
		TextField textField = new TextField(stringValue);
		textField.setEditable(editable);
		nameToTextField.put(name, textField);
		content.addRow(rowNumber, label, textField);
		GridPane.setHalignment(label, HPos.RIGHT);
	}

}
